searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `ElixirExtensions`.","ref":"ElixirExtensions.html","title":"ElixirExtensions","type":"module"},{"doc":"Extend Repo with some useful functions.\nAdd this line to your repo:\n\n  use ElixirExtensions.Core","ref":"ElixirExtensions.Core.html","title":"ElixirExtensions.Core","type":"module"},{"doc":"Functions to transform maps","ref":"ElixirExtensions.Core.MapExt.html","title":"ElixirExtensions.Core.MapExt","type":"module"},{"doc":"Convert map string keys to :atom keys","ref":"ElixirExtensions.Core.MapExt.html#atomize_keys/1","title":"ElixirExtensions.Core.MapExt.atomize_keys/1","type":"function"},{"doc":"Deep merge two maps","ref":"ElixirExtensions.Core.MapExt.html#deep_merge/2","title":"ElixirExtensions.Core.MapExt.deep_merge/2","type":"function"},{"doc":"Convert map atom keys to strings","ref":"ElixirExtensions.Core.MapExt.html#stringify_keys/1","title":"ElixirExtensions.Core.MapExt.stringify_keys/1","type":"function"},{"doc":"iex> stringify_keys(%{hello: \"world\"})\n  %{\"hello\" => \"world\"}","ref":"ElixirExtensions.Core.MapExt.html#stringify_keys/1-examples","title":"Examples - ElixirExtensions.Core.MapExt.stringify_keys/1","type":"function"},{"doc":"Convert map string camelCase keys to underscore_keys","ref":"ElixirExtensions.Core.MapExt.html#underscore_keys/1","title":"ElixirExtensions.Core.MapExt.underscore_keys/1","type":"function"},{"doc":"iex> underscore_keys(%{\"helloWorld\" => \"elixirHi\"})\n    %{\"hello_world\" => \"elixirHi\"}","ref":"ElixirExtensions.Core.MapExt.html#underscore_keys/1-examples","title":"Examples - ElixirExtensions.Core.MapExt.underscore_keys/1","type":"function"},{"doc":"Functions to string truncate","ref":"ElixirExtensions.Core.StringExt.html","title":"ElixirExtensions.Core.StringExt","type":"module"},{"doc":"Copied from https://github.com/ikeikeikeike/phoenix_html_simplified_helpers/blob/master/lib/phoenix_html_simplified_helpers/truncate.ex","ref":"ElixirExtensions.Core.StringExt.html#truncate/2","title":"ElixirExtensions.Core.StringExt.truncate/2","type":"function"},{"doc":"iex> truncate(\"hello world\", length: 5)\n    \"he...\"","ref":"ElixirExtensions.Core.StringExt.html#truncate/2-examples","title":"Examples - ElixirExtensions.Core.StringExt.truncate/2","type":"function"},{"doc":"Extend Changeset with some useful functions.\nAdd this line to your schema file:\n\ndefmodule MyApp.Accounts.User do\n  use Ecto.Schema\n  import Ecto.Changeset\n  alias ElixirExtensions.Ecto.ChangesetExt\n  ...\nend\n\nSome extra validations for you to use:\n\ntrim(changeset, :field)\ntrim(changeset, [:field1, :field2])\nvalidate_email(changeset, :field)\nvalidate_url(changeset, field)","ref":"ElixirExtensions.Ecto.ChangesetExt.html","title":"ElixirExtensions.Ecto.ChangesetExt","type":"module"},{"doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#email_valid?/1","title":"ElixirExtensions.Ecto.ChangesetExt.email_valid?/1","type":"function"},{"doc":"Trims the whitespace off both ends of the string.\n\"  John Doe \" -> \"John Doe\"\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:first_name, :last_name, :email])\n      |> trim([:first_name, :last_name])\n      |> trim(:email)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#ensure_trimmed/2","title":"ElixirExtensions.Ecto.ChangesetExt.ensure_trimmed/2","type":"function"},{"doc":"Trim whitespace on either end of a string. Account for nil","ref":"ElixirExtensions.Ecto.ChangesetExt.html#trim/1","title":"ElixirExtensions.Ecto.ChangesetExt.trim/1","type":"function"},{"doc":"Validate emails. Will check mx records in production (see the email_checker library).\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:email])\n      |> validate_email(:email)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_email/2","title":"ElixirExtensions.Ecto.ChangesetExt.validate_email/2","type":"function"},{"doc":"Validate URLs. Adds https if a scheme doesn't exist.\neg. \"google.com\" -> \"https://google.com\"\n\nExamples:\n\n    defp changeset(user) do\n      user\n      |> cast([:website])\n      |> validate_and_fix_url(:website)\n    end","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_url/2","title":"ElixirExtensions.Ecto.ChangesetExt.validate_url/2","type":"function"},{"doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_url_works/2","title":"ElixirExtensions.Ecto.ChangesetExt.validate_url_works/2","type":"function"},{"doc":"","ref":"ElixirExtensions.Ecto.ChangesetExt.html#validate_website_link/1","title":"ElixirExtensions.Ecto.ChangesetExt.validate_website_link/1","type":"function"},{"doc":"Extend Ecto.Query with some useful functions.\nAdd this line to your Context module:\n\n    import Ecto.Query, warn: false\n    alias ElixirExtensions.Ecto.QueryExt","ref":"ElixirExtensions.Ecto.QueryExt.html","title":"ElixirExtensions.Ecto.QueryExt","type":"module"},{"doc":"Limit a the number of results from a query. Can be compined with other queryables\nUserQuery.text_search(\"Kyle\") |> QueryExt.limit(query, 5)","ref":"ElixirExtensions.Ecto.QueryExt.html#limit/2","title":"ElixirExtensions.Ecto.QueryExt.limit/2","type":"function"},{"doc":"order_by(query, [:name, :population])\norder_by(query, [asc: :name, desc_nulls_first: :population])","ref":"ElixirExtensions.Ecto.QueryExt.html#order_by/2","title":"ElixirExtensions.Ecto.QueryExt.order_by/2","type":"function"},{"doc":"Order by newest first","ref":"ElixirExtensions.Ecto.QueryExt.html#order_newest_first/1","title":"ElixirExtensions.Ecto.QueryExt.order_newest_first/1","type":"function"},{"doc":"Order by oldest first","ref":"ElixirExtensions.Ecto.QueryExt.html#order_oldest_first/1","title":"ElixirExtensions.Ecto.QueryExt.order_oldest_first/1","type":"function"},{"doc":"Preload associations.\nUserQuery.text_search(\"Kyle\") |> QueryExt.preload(:posts) |> Repo.all()","ref":"ElixirExtensions.Ecto.QueryExt.html#preload/2","title":"ElixirExtensions.Ecto.QueryExt.preload/2","type":"function"},{"doc":"Construct a where query on the fly. Only works when `use QueryBuilder` is added to the schema file\neg QueryExt.where(Log, %{post_id: 1814, user_id: 24688, user_type: \"user\"}) |> Repo.all()","ref":"ElixirExtensions.Ecto.QueryExt.html#where/2","title":"ElixirExtensions.Ecto.QueryExt.where/2","type":"function"},{"doc":"Extend Repo with some useful functions.\nAdd this line to your repo:\n\ndefmodule MyApp.Repo do\n  use Ecto.Repo,\n    otp_app: :petal_pro,\n    adapter: Ecto.Adapters.Postgres\n\n  use ElixirExtensions.Ecto.RepoExt\nend","ref":"ElixirExtensions.Ecto.RepoExt.html","title":"ElixirExtensions.Ecto.RepoExt","type":"module"},{"doc":"# ElixirExtensions\n\nA set of convenient extensions for developing services with Elixir/Phoenix","ref":"readme.html","title":"ElixirExtensions","type":"extras"},{"doc":"the package can be installed by adding `elixir_extensions` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:elixir_extensions, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - ElixirExtensions","type":"extras"},{"doc":"#","ref":"readme.html#usage","title":"Usage - ElixirExtensions","type":"extras"},{"doc":"- For extending `String`, `Map` utility functions.\n```elixir\n  use ElixirExtensions # import core extentions\n```\n- `underscore_keys`\n```elixir\niex> underscore_keys(%{\"helloWorld\" => \"elixirHi\"})\n%{\"hello_world\" => \"elixirHi\"}\n```\n- `truncate`\n```elixir\niex> truncate(\"hello world\", length: 5)\n\"he...\"\n```\n- `stringify_keys`\n```elixir\niex> stringify_keys(%{hello: \"world\"})\n%{\"hello\" => \"world\"}\n```\n#","ref":"readme.html#core-string-map","title":"Core(String,Map) - ElixirExtensions","type":"extras"},{"doc":"- Extend Repo with some useful functions.\n```elixir\n  defmodule MyApp.Repo do\n    use Ecto.Repo,\n      otp_app: :petal_pro,\n      adapter: Ecto.Adapters.Postgres\n\n    use ElixirExtensions.Ecto.RepoExt # Add this line to your repo.\n  end\n```\n- Extend Changeset with some useful functions.\n```elixir\n defmodule MyApp.Accounts.User do\n    use Ecto.Schema\n    import Ecto.Changeset\n    alias ElixirExtensions.Ecto.ChangesetExt #  Add this line to your schema file.\n    ...\n  end\n```\n- Extend Ecto.Query with some useful functions.\n```elixir\n  import Ecto.Query, warn: false\n  alias ElixirExtensions.Ecto.QueryExt #  Add this line to your Context module file.\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#ecto","title":"Ecto - ElixirExtensions","type":"extras"}]}